#include <cstdlib>
#include <cstring>
#include <deque>
#include <fstream>
#include <iostream>
#include <sstream>

using namespace std;

const int maxn = 200010;

int n;
int g[maxn], next1[maxn], d[maxn];
bool removed[maxn];

string p, t;
string err_msg;
int err_code;

int check(ifstream& f)
{
    int v;
    f >> v;
    if (!f) {
        err_msg = "unexpected end of output";
        err_code = 2;
        return -1;
    }
    if (v < 1 || v > n) {
        ostringstream ss;
        ss << "illegal vertex #" << v << " in the output";
        err_msg = ss.str();
        err_code = 1;
        return -1;
    }
    if (removed[v]) {
        ostringstream ss;
        ss << "removed vertex #" << v << " in the output";
        err_msg = ss.str();
        err_code = 1;
        return -1;
    }
    return d[v];
}

void dfs(int v)
{
    removed[v] = true;
    int i = g[v];
    while (i) {
        if (!removed[i]) dfs(i);
        i = next1[i];
    }
}

int main(int argc, char* argv[])
{
    ifstream fin(argv[1]);
    ifstream fout(argv[2]);
    ifstream fans(argv[3]);

    int actions;
    fin >> actions;
    int inserts = 0, deletes = 0;
    n = 1;
    for (int i = 0; i < actions; i++) {
        int v;
        fin >> v;
        if (v > 0) {
            inserts++;
            n++;
            next1[n] = g[v]; g[v] = n;
            d[n] = d[v] + 1;
        } else {
            deletes++;
            v = -v;
            dfs(v);
        }

        int jury_ans = check(fans);
        if (jury_ans == -1) {
            cout << "jury error: " << err_msg << " on action " << i+1 << endl;
            return 3;
        }

        int cont_ans = check(fout);
        if (cont_ans == -1) {
            cout << "contestant error: " << err_msg << " on action " << i+1 << endl;
            return err_code;
        }

        if (cont_ans > jury_ans) {
            cout << "contestant is better: " << cont_ans << " vs. " << jury_ans 
                 << " on action " << i+1 << endl;
            return 3;
        }

        if (cont_ans < jury_ans) {
            cout << "jury is better: " << cont_ans << " vs. " << jury_ans 
                 << " on action " << i+1 << endl;
            return 1;
        }
    }

    cout << "ok, " << inserts << " inserts, " << deletes << " deletes" << endl;
    return 0;
}
