#include <cstdlib>
#include <iostream>
#include <sstream>

using namespace std;

const int maxn = 1 << 18;

int t[maxn << 1];
int g[maxn], next1[maxn];
int n;

int mrand(int x)
{
    if (RAND_MAX >= maxn)
        return rand() % x;
    else  
        return (rand()*(unsigned int)rand() + rand()) % x;
}

void update(int i, int val) 
{
    int x = maxn + i;
    t[x] = val;
    while (x/2 > 0) {
        x /= 2;
        t[x] = t[x*2] + t[x*2+1];
    }
}

int find(int i)
{
    int x = 1;
    int sum = 0;
    while (x < maxn) {
        if (t[x*2] >= i - sum) {
            x = x*2;
        } else {
            sum += t[x*2];
            x = x*2 + 1;
        }
    }
    return x - maxn;
}

int get(int i)
{
    return t[maxn + i];
}

void add(int v, int p) 
{
    n++;
    update(v, 1);
    next1[v] = g[p]; g[p] = v;
}

void remove(int v) 
{
    n--;
    update(v, 0);
    int i = g[v];
    while (i) {
        if (get(i)) remove(i);
        i = next1[i];
    }
}

int main(int argc, char* argv[])
{
    int actions, randseed;
    double l, r, remove_fraction;
    istringstream ss1(argv[1]);
    ss1 >> actions;
    istringstream ss2(argv[2]);
    ss2 >> remove_fraction;
    istringstream ss3(argv[3]);
    ss3 >> l;
    istringstream ss4(argv[4]);
    ss4 >> r;
    istringstream ss5(argv[5]);
    ss5 >> randseed;

    srand(randseed);

    update(1, 1);

    cout << actions << endl;

    n = 1;
    int last_num = 1;
    for (int sc = 0; sc < actions; sc++) {
        int action = +1;
        if (n > 1 && mrand(1000000) < remove_fraction*1000000)
            action = -1;
        if (action == +1) {
            int L = l * (n-1) + 1;
            int R = r * (n-1) + 1;
            int k = L + mrand(R-L+1);
            int v = find(k);
            add(++last_num, v);
            cout << "+" << v << endl;
        } else {
            int k = mrand(n-1) + 2;
            int v = find(k);
            remove(v);
            cout << "-" << v << endl;
        }
    }

    return 0;
}
