#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <queue>
#include <string>
#include <vector>

using namespace std;

const int maxn = 200010;

int n;
int g[maxn], next1[maxn], d[maxn];
bool removed[maxn];

class v_less {
public:
  bool operator() (const int& l, const int& r) const {
    return d[l] < d[r];
  }
};

//В куче q содержатся номера вершин. На вершине кучи всегда будет самый далёкий
//лист. Удаление произвольного элемента из priority_queue едва ли возможно, 
//поэтому мы храним и удалённые вершины, просто пропускаем их, если они
//оказываются на вершине кучи.
priority_queue<int, vector<int>, v_less> q;

void dfs(int v)
{
    removed[v] = true;
    int i = g[v];
    while (i) {
        //Условие важно. Благодаря нему мы посещаем в dfs каждую вершину
        //только один раз за время работы программы. 
        if (!removed[i]) dfs(i);
        i = next1[i];
    }
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    n = 1; //Инвариант: n - номер последней добавленной вершины.
    q.push(1);

    int actions;
    cin >> actions;
    for (int i = 0; i < actions; i++) {
        int v;
        cin >> v;
        if (v > 0) {
            n++;
            next1[n] = g[v]; g[v] = n;
            d[n] = d[v] + 1;
            q.push(n);
        } else {
            v = -v;
            dfs(v);
        }
        while (removed[q.top()]) q.pop();
        cout << q.top() << endl;
    }

    fclose(stdin); fclose(stdout);
    return 0;
}
